import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../common";
export type MessageStruct = {
    value: PromiseOrValue<BigNumberish>;
    sender: PromiseOrValue<string>;
    client: PromiseOrValue<string>;
    chainId: PromiseOrValue<BigNumberish>;
};
export type MessageStructOutput = [BigNumber, string, string, number] & {
    value: BigNumber;
    sender: string;
    client: string;
    chainId: number;
};
export interface MultichainPostmanInterface extends utils.Interface {
    functions: {
        "anyCall()": FunctionFragment;
        "anyExecute(bytes)": FunctionFragment;
        "anycallExecutor()": FunctionFragment;
        "deliverMessage((uint256,address,address,uint16),address,address,uint8,uint16)": FunctionFragment;
        "owner()": FunctionFragment;
        "renounceOwnership()": FunctionFragment;
        "transferOwnership(address)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "anyCall" | "anyExecute" | "anycallExecutor" | "deliverMessage" | "owner" | "renounceOwnership" | "transferOwnership"): FunctionFragment;
    encodeFunctionData(functionFragment: "anyCall", values?: undefined): string;
    encodeFunctionData(functionFragment: "anyExecute", values: [PromiseOrValue<BytesLike>]): string;
    encodeFunctionData(functionFragment: "anycallExecutor", values?: undefined): string;
    encodeFunctionData(functionFragment: "deliverMessage", values: [
        MessageStruct,
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "owner", values?: undefined): string;
    encodeFunctionData(functionFragment: "renounceOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [PromiseOrValue<string>]): string;
    decodeFunctionResult(functionFragment: "anyCall", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "anyExecute", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "anycallExecutor", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deliverMessage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "renounceOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
    events: {
        "MessageReceived(address,uint256,address,uint16,uint256)": EventFragment;
        "OwnershipTransferred(address,address)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "MessageReceived"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
}
export interface MessageReceivedEventObject {
    srcVaultAddress: string;
    amount: BigNumber;
    dstVaultAddress: string;
    messageType: number;
    srcChainId: BigNumber;
}
export type MessageReceivedEvent = TypedEvent<[
    string,
    BigNumber,
    string,
    number,
    BigNumber
], MessageReceivedEventObject>;
export type MessageReceivedEventFilter = TypedEventFilter<MessageReceivedEvent>;
export interface OwnershipTransferredEventObject {
    previousOwner: string;
    newOwner: string;
}
export type OwnershipTransferredEvent = TypedEvent<[
    string,
    string
], OwnershipTransferredEventObject>;
export type OwnershipTransferredEventFilter = TypedEventFilter<OwnershipTransferredEvent>;
export interface MultichainPostman extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: MultichainPostmanInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        anyCall(overrides?: CallOverrides): Promise<[string]>;
        anyExecute(_data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        anycallExecutor(overrides?: CallOverrides): Promise<[string]>;
        deliverMessage(_msg: MessageStruct, _dstVautAddress: PromiseOrValue<string>, _dstPostman: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _dstChainId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        owner(overrides?: CallOverrides): Promise<[string]>;
        renounceOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
    };
    anyCall(overrides?: CallOverrides): Promise<string>;
    anyExecute(_data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    anycallExecutor(overrides?: CallOverrides): Promise<string>;
    deliverMessage(_msg: MessageStruct, _dstVautAddress: PromiseOrValue<string>, _dstPostman: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _dstChainId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    owner(overrides?: CallOverrides): Promise<string>;
    renounceOwnership(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        anyCall(overrides?: CallOverrides): Promise<string>;
        anyExecute(_data: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<[boolean, string] & {
            success: boolean;
            result: string;
        }>;
        anycallExecutor(overrides?: CallOverrides): Promise<string>;
        deliverMessage(_msg: MessageStruct, _dstVautAddress: PromiseOrValue<string>, _dstPostman: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _dstChainId: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        owner(overrides?: CallOverrides): Promise<string>;
        renounceOwnership(overrides?: CallOverrides): Promise<void>;
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
    };
    filters: {
        "MessageReceived(address,uint256,address,uint16,uint256)"(srcVaultAddress?: null, amount?: null, dstVaultAddress?: null, messageType?: null, srcChainId?: null): MessageReceivedEventFilter;
        MessageReceived(srcVaultAddress?: null, amount?: null, dstVaultAddress?: null, messageType?: null, srcChainId?: null): MessageReceivedEventFilter;
        "OwnershipTransferred(address,address)"(previousOwner?: PromiseOrValue<string> | null, newOwner?: PromiseOrValue<string> | null): OwnershipTransferredEventFilter;
        OwnershipTransferred(previousOwner?: PromiseOrValue<string> | null, newOwner?: PromiseOrValue<string> | null): OwnershipTransferredEventFilter;
    };
    estimateGas: {
        anyCall(overrides?: CallOverrides): Promise<BigNumber>;
        anyExecute(_data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        anycallExecutor(overrides?: CallOverrides): Promise<BigNumber>;
        deliverMessage(_msg: MessageStruct, _dstVautAddress: PromiseOrValue<string>, _dstPostman: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _dstChainId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<BigNumber>;
        renounceOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        anyCall(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        anyExecute(_data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        anycallExecutor(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        deliverMessage(_msg: MessageStruct, _dstVautAddress: PromiseOrValue<string>, _dstPostman: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _dstChainId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        renounceOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
    };
}
